// sizes.cpp
// this program will demonstrate the second characteristic
// of a memory container - length.
#include <iostream.h>
#include <iomanip.h>

class aClass {
	private:
		int oneint;
		int twoint;
	public:
		aClass() {oneint=0; twoint=0; }
		aClass(int a, int b)
			{oneint = a; twoint = b;}
		~aClass() { }
		int getints(int &a, int &b);
		void showints();
};

void aClass::showints()
{
	cout << "oneint is " << oneint << endl;
	cout << "twoint is " << twoint << endl;
}

int main()
{	
	char aChar      = 'a';
	int anInt       = 10 ;
	float aFloat    = 3.5;
	double aDouble  = 400.999;
	aClass Classobj(30,40);
	
	// let's look at the three characteristics of each
	// container - 1) address 2) length 3) value
	cout << "aChar is a character container." << endl;
	cout << "aChar's address is " << (void *) &aChar << endl;
	cout << "aChar's length is " << sizeof(aChar) << endl;
	cout << "aChar's value is " << aChar << endl;
	cout << "----------------------------------" << endl;
	cout << "anInt is an integer container." << endl;
	cout << "anInt's address is " << &anInt << endl;
	cout << "anInt's length is " << sizeof(anInt) << endl;
	cout << "anInt's value is " << anInt << endl;
	cout << "----------------------------------" << endl;
	cout << "aFloat is a float container." << endl;
	cout << "aFloat's address is " << &aFloat << endl;
	cout << "aFloat's length is " << sizeof(aFloat) << endl;
	cout << "aFloat's value is " << aFloat << endl;
	cout << "----------------------------------" << endl;
	cout << "aDouble is a double container." << endl;
	cout << "aDouble's address is " << &aDouble << endl;
	cout << "aDouble's length is " << sizeof(aDouble) << endl;
	cout << "aDouble's value is " << aDouble << endl;
	cout << "----------------------------------" << endl;
	cout << "Classobj is a class container." << endl;
	cout << "Classobj's address is " << &Classobj << endl;
	cout << "Classobj's length is " << sizeof(Classobj) << endl;
	cout << "Classobj's value is :" << endl;
	// Notice a classes data is protected. This is 
	// Encapsulation. (a "lock" on the "box")
	Classobj.showints();
	cout << "----------------------------------" << endl;
	return 0;
}
