// voidptr.cpp
#include <iostream.h>
#include <iomanip.h>

#define INTEGER 1
#define FLOAT 2

void print_type(void *vptr, int type)
{
	switch (type) {
		case INTEGER:
			cout << "Integer is " << *((int *)vptr) << endl;
			break;
		case FLOAT:
			cout << "Float is " << *((float *)vptr) << endl;
			break;
	};
}

void main()
{
	int myint=10;
	float myfloat=2.56;
	void *vp1 = &myint;
	print_type(vp1,INTEGER);
	
	vp1 = &myfloat;
	print_type(vp1,FLOAT);
}
