// books.cpp
#include <iostream.h>
#include <iomanip.h>
#include <string.h>

class Book {
		char title[80];
		char author[80];
		char publisher[80];
		int pages;
		int copyright;
		short read_flag;
	public:
		Book();
		Book(char *intitle, char *inauthor,
		     char *inpublisher, int inpages,
		     int incopyright, short inread_flag);
		~Book();
		friend istream &operator >> (istream &stream, Book &inobj);
		friend ostream &operator << (ostream &stream, Book &inobj);
};

Book::Book()
{
	cout << "Calling noarg Book constructor." << endl;
	strcpy(title," ");
	strcpy(author," ");
	strcpy(publisher," ");
	pages = copyright = read_flag = 0;
}

Book::Book(char *intitle, char *inauthor, char *inpublisher,
           int inpages, int incopyright, short inread_flag)
{
	cout << "Calling multi-arg Book constructor." << endl;
	strcpy(title, intitle);
	strcpy(author, inauthor);
	strcpy(publisher, inpublisher);
	pages = inpages;
	copyright = incopyright;
	read_flag = inread_flag;
}

Book::~Book()
{
	cout << "Calling Book Destructor." << endl;
}

istream &operator >> (istream &stream, Book &inobj)
{
	char yesno[80];
	
	cout << "Enter Title: ";
	stream.getline(inobj.title,80);
	cout << "Enter Author: ";
	stream.getline(inobj.author,80);
	cout << "Enter Publisher: ";
	stream.getline(inobj.publisher,80);
	cout << "Enter number of pages: ";
	stream >> inobj.pages;
	cout << "Enter copyright year: ";
	stream >> inobj.copyright;
	cout << "Read this book (y/n)? ";
	stream >> yesno;
	if ( (!strncmp(yesno,"y",1)) || (!strncmp(yesno,"Y",1)) )
		inobj.read_flag = 1;
	else
		inobj.read_flag = 0;
	stream.ignore(20,'\n');
	return stream;
}

ostream &operator << (ostream &stream, Book &inobj)
{
	stream << "Title     : " << inobj.title << endl;
	stream << "Author    : " << inobj.author << endl;
	stream << "Publisher : " << inobj.publisher << endl;
	stream << "# Pages   : " << inobj.pages << endl;
	stream << "Copyright : " << inobj.copyright << endl;
	stream << "Read?     : " << ((inobj.read_flag) ? "Yes" : "No") 
	                         << endl;
	return stream;
}

const int MAXBOOKS = 3;

void main()
{
	Book library[MAXBOOKS];
	int i=0;
	
	for (i=0; i < MAXBOOKS; i++)
		cin >> library[i];
		
	for (i=0; i < MAXBOOKS; i++)
		cout << library[i];
}
