// classtst.cpp
#include <iostream.h>
#include <iomanip.h>
#include <string.h>

class food {
	private:
		char name[80];
		char brand[80];
		int serving_sz;  // in ounces
		int calories;
		float  fat_grams;
	public:
		food() { cout << "constructing object." << endl; };
		~food() { cout << "destructing object." << endl; };
		food(char *inname, char *inbrand, int serving, 
			             int incalories, float fat);
		void set(char *inname, char *inbrand, int serving,
		         int incalories, float fat);
		void display();
		int get_calories();
		float get_fat();
};

food::food(char *inname, char *inbrand, int serving, 
            int incalories, float fat)
{
	cout << "overloaded constructor." << endl;
	strcpy(name,inname);
	strcpy(brand,inbrand);
	serving_sz = serving;
	calories = incalories;
	fat_grams = fat;
}

void food::set(char *inname, char *inbrand, int serving, 
            int incalories, float fat)
{
	strcpy(name,inname);
	strcpy(brand,inbrand);
	serving_sz = serving;
	calories = incalories;
	fat_grams = fat;
}

void food::display()
{
	cout << "Food name  : " << name << endl;
	cout << "     brand : " << brand << endl;
	cout << " serving_sz: " << serving_sz << endl;
	cout << "   calories: " << calories << endl;
	cout << "  fat grams: " << fat_grams << endl;
}

int food::get_calories()
{	
	return calories;
}

float food::get_fat()
{
	return fat_grams;
}


void main()
{
	food cereal;     // no arg constructor
	food *cerealp = &cereal;
	food pizza("pizza", "tombstone", 16, 600, 21.6);
	
	pizza.display();
	
	cereal.set("Oatmeal", "Quaker", 8, 100, 2.1);
	cerealp->display();	
}
