// chngprio.cpp
#include <iostream.h>
#include <string.h>
#include <ctype.h>

void func1(char *arg1)
{
	cout << "Performing action 1 on " << arg1 << endl;
}

void func2(char *arg1)
{
	cout << "Performing action 2 on" << arg1 << endl;
}

void func3(char *arg1)
{
	cout << "Performing action 3 on " << arg1 << endl;
}

void func4(char *arg1)
{
	cout << "Performing action 4 on " << arg1 << endl;
}

void (*initial[4]) (char *arg1) = {func1, func2, func3, func4};
void (**action) (char *arg1);

void do_action(int type, char *instr)
{
	if ( (type >= 0) && (type <= 3) )
		(*action[type]) (instr);
}

void main()
{
	int i=0,j=0;
			
	action = new (void (*[4]) (char *));
	for (i = 0; i < 4; i++)
			action[i] = initial[i];

	cout << "Before priority adjustment." << endl;	
	for (i = 0; i < 4; i++)
		do_action(i, "object");
	cout << endl;
		
	/* reverse priorities */
	for (i = 0, j = 3; i < 4; i++,j--)
		action[i] = initial[j];

	cout << "After priority adjustment." << endl;	
	for (i = 0; i < 4; i++)
		do_action(i, "object");
}